// Registry Key View
// Don`t forget uncomment "Delete" function :)))

#include <windows.h>
#include <windowsx.h>
#include <winreg.h>
#include <shellapi.h>
#include <winuser.h>
//#include <iostream.h>
//#include <strstrea.h>
#include <stdio.h>
//#include <string.h>
#include <iomanip.h>
#include "resource.h"

#define szRegRoot "SOFTWARE\\WhiteUnicorn\\ViewRegKey"

HKEY  aRootKeyName[6]  = { HKEY_CLASSES_ROOT ,  HKEY_CURRENT_USER ,  HKEY_LOCAL_MACHINE , HKEY_USERS, HKEY_CURRENT_CONFIG, HKEY_DYN_DATA};
char*  chRootKeyName[6] = {"HKEY_CLASSES_ROOT", "HKEY_CURRENT_USER", "HKEY_LOCAL_MACHINE","HKEY_USERS", "HKEY_CURRENT_CONFIG", "HKEY_DYN_DATA"};
HKEY  hKey;
HKEY  szRootKeyName;      //HKEY_LOCAL_MACHINE
HINSTANCE g_inst;
HFONT hFont = NULL;
DWORD iRootKeyName;
DWORD dt = REG_SZ;
DWORD sz;
char  szKeyName[255];     //SOFTWARE\Microsoft\Windows\CurrentVersion
char  szValueName[255];   //QMOpen
char  szKeyName00[255],szKeyName01[255],szKeyName02[255],szValueName00[255],szValueName01[255],szValueName02[255];
char* chMessage=NULL;
char  chTitle[100];       // MessageBox title

BOOL WINAPI VRegKeyWindowProc  (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

BOOL VRegKey_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
void VRegKey_OnClose     (HWND hwnd);
void VRegKey_OnCommand   (HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

void View       (HWND hwnd);
void DelValueYes(HWND hwnd);
void SaveReg    (HWND hwnd);
void LoadReg    ();

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR szCmdLine, int nCmdShow)
{
  g_inst = hInstance;
  LoadReg();
  return DialogBox(hInstance,  MAKEINTRESOURCE (IDD_REGKEY_DIALOG), NULL, (DLGPROC)VRegKeyWindowProc);
}

BOOL WINAPI VRegKeyWindowProc  (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    HANDLE_MSG(hwnd, WM_INITDIALOG, VRegKey_OnInitDialog);
    HANDLE_MSG(hwnd, WM_CLOSE     , VRegKey_OnClose     );
    HANDLE_MSG(hwnd, WM_COMMAND   , VRegKey_OnCommand   );
    default:
      return FALSE;
  }
  //return TRUE;
} // BOOL WINAPI VRegKeyWindowProc

BOOL VRegKey_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
  HWND hRootKey   = GetDlgItem(hwnd, IDC_ROOTKEY_CBOX);
  HWND hKeyName   = GetDlgItem(hwnd, IDC_KEYNAME_CBOX);
  HWND hValueName = GetDlgItem(hwnd, IDC_VALUENAME_CBOX);

  for(short i = 0; i<6; i++)
    {ComboBox_AddString(hRootKey, chRootKeyName[i]);}
  ComboBox_SetCurSel(hRootKey, iRootKeyName);

  if (strlen(szKeyName00) != 0) ComboBox_AddString(hKeyName, szKeyName00);
  if (strlen(szKeyName01) != 0) ComboBox_AddString(hKeyName, szKeyName01);
  if (strlen(szKeyName02) != 0) ComboBox_AddString(hKeyName, szKeyName02);
  ComboBox_SetCurSel(hKeyName, 0);

  if (strlen(szValueName00) != 0) ComboBox_AddString(hValueName, szValueName00);
  if (strlen(szValueName01) != 0) ComboBox_AddString(hValueName, szValueName01);
  if (strlen(szValueName02) != 0) ComboBox_AddString(hValueName, szValueName02);
  ComboBox_SetCurSel(hValueName, 0);

  static LOGFONT LogFont;
  static TEXTMETRIC TextMetrics;
  static char FontName[]="Courier New";

  if (GetTextMetrics(GetDC(GetDlgItem(hwnd, IDC_EB_VALUE)), &TextMetrics))
  {
    memset(&LogFont, 0, sizeof(LOGFONT));
    LogFont.lfHeight=TextMetrics.tmHeight;
    LogFont.lfCharSet=RUSSIAN_CHARSET;
    strcpy(LogFont.lfFaceName, FontName);

    if (hFont != NULL) DeleteObject(hFont);
    hFont=CreateFontIndirect(&LogFont);

    if (hFont != NULL)
      SendDlgItemMessage(hwnd, IDC_EB_VALUE, WM_SETFONT, (WPARAM) hFont, MAKELPARAM(TRUE, 0));
  }

  SendMessage(hwnd, WM_COMMAND, IDC_PB_REFRESH,NULL);

  return TRUE;
} // BOOL VRegKey_OnInitDialog

void VRegKey_OnClose(HWND hwnd)
{
  HWND hRootKey=GetDlgItem(hwnd, IDC_ROOTKEY_CBOX);
  HWND hKeyName=GetDlgItem(hwnd, IDC_KEYNAME_CBOX);
  HWND hValueName=GetDlgItem(hwnd, IDC_VALUENAME_CBOX);

  iRootKeyName = ComboBox_GetCurSel(hRootKey);

  ComboBox_GetLBText(hKeyName,   0, szKeyName00);
  ComboBox_GetLBText(hKeyName,   1, szKeyName01);
  ComboBox_GetLBText(hKeyName,   2, szKeyName02);
  ComboBox_GetLBText(hValueName, 0, szValueName00);
  ComboBox_GetLBText(hValueName, 1, szValueName01);
  ComboBox_GetLBText(hValueName, 2, szValueName02);
  SaveReg(hwnd);

  if (hFont != NULL) DeleteObject(hFont);

  EndDialog (hwnd, TRUE);

} // void VRegKey_OnClose

void VRegKey_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    int iKeyName;
    int iValueName;

    switch (id)
    {
      case IDC_PB_REFRESH:
      {
        szRootKeyName = aRootKeyName[SendDlgItemMessage(hwnd, IDC_ROOTKEY_CBOX, CB_GETCURSEL, 0, 0)];

        if (GetDlgItemText(hwnd, IDC_KEYNAME_CBOX,   szKeyName,   255 ) != 0)
        {
          iKeyName = SendDlgItemMessage(hwnd, IDC_KEYNAME_CBOX, CB_FINDSTRINGEXACT, 1,(LPARAM)szKeyName);
          if ( iKeyName != CB_ERR )
            {SendDlgItemMessage(hwnd, IDC_KEYNAME_CBOX, CB_DELETESTRING, iKeyName,0);}
          SendDlgItemMessage(hwnd, IDC_KEYNAME_CBOX, CB_INSERTSTRING, 0,(LPARAM)szKeyName);
          SendDlgItemMessage(hwnd, IDC_KEYNAME_CBOX, CB_SETCURSEL, 0, 0);
        }

        if (GetDlgItemText(hwnd, IDC_VALUENAME_CBOX, szValueName, 255 ) != 0)
        {
          iValueName = SendDlgItemMessage(hwnd, IDC_VALUENAME_CBOX, CB_FINDSTRINGEXACT, 1,(LPARAM)szValueName);
          if ( iValueName != CB_ERR )
            {SendDlgItemMessage(hwnd, IDC_VALUENAME_CBOX, CB_DELETESTRING, iValueName,0);}
          SendDlgItemMessage(hwnd, IDC_VALUENAME_CBOX, CB_INSERTSTRING, 0,(LPARAM)szValueName);
          SendDlgItemMessage(hwnd, IDC_VALUENAME_CBOX, CB_SETCURSEL, 0, 0);
        }
        View(hwnd);
        UpdateWindow(hwnd);
        break;
      } // case IDC_PB_REFRESH:

      case IDC_PB_DELETE:
      {
        DelValueYes(hwnd);
        break;
      } // case IDC_PB_DELETE:

      case IDC_PB_CLOSE:
      {
        SendMessage(hwnd, WM_CLOSE,NULL,NULL);
        break;
      }  // case IDC_PB_CLOSE

      case IDC_ROOTKEY_CBOX:
      {
        switch (codeNotify)
        {
          case CBN_SELENDOK:
            SendMessage(hwnd, WM_COMMAND, IDC_PB_REFRESH,NULL);
            break;
        } // switch (codeNotify)
      } // case IDC_ROOTKEY_CBOX:

      case IDC_KEYNAME_CBOX:
      {
        switch (codeNotify)
        {
          case CBN_KILLFOCUS:
            SendMessage(hwnd, WM_COMMAND, IDC_PB_REFRESH,NULL);
            break;
        } // switch (codeNotify)
      } // case IDC_KEYNAME_CBOX:

      case IDC_VALUENAME_CBOX:
      {
        switch (codeNotify)
        {
          case CBN_KILLFOCUS:
            SendMessage(hwnd, WM_COMMAND, IDC_PB_REFRESH,NULL);
            break;
        } // switch (codeNotify)
      } // case IDC_VALUENAME_CBOX:

    } // switch (id)

} // void VRegKey_OnCommand


void View(HWND hwnd)
{
  char* szKeyValue=NULL;
  int iValueIndex = 0;
  //strstream ostrKeyValue;

  if (RegOpenKeyEx(szRootKeyName, szKeyName,0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
  {
   if (strlen(szValueName) >0)
   {
     sz=1;
     if (RegQueryValueEx(hKey, szValueName, NULL, &dt, (LPBYTE)szKeyValue, &sz) == ERROR_SUCCESS)
     {
       szKeyValue = new char[sz];

       //chMessage  = new char[4*sz];
       RegQueryValueEx(hKey, szValueName, NULL, &dt, (LPBYTE)szKeyValue, &sz);
       switch (dt)
       {
         case REG_SZ:
         {
           chMessage  = new char[sz+32];
           wsprintf (chMessage, "String Value \r\n\r\n%s",szKeyValue);
           //ostrKeyValue << "String Value \r\n\r\n" << szKeyValue;
           break;
         } // case REG_SZ:

         case REG_BINARY:
         {
		   chMessage  = new char[4*sz];
           char chTemp[2048]="";
           char _chTemp[5];
           //char chMesTemp[100];
           //int  iBytes ;
           int  iCounter = 0;

           //ostrKeyValue << "Binary Value\r\n\r\n";

           //if (sz > 160 ) {iBytes = 160 ;} else { iBytes = sz;}

           //for (unsigned int i = 0; i < iBytes; i++)
           for (unsigned int i = 0; i < sz; i++)
           {
             wsprintf(&_chTemp[0], "%04x",(unsigned short int)(szKeyValue[i]) );
             lstrcat(chTemp, &_chTemp[2]);
             lstrcat(chTemp, " ");
             //ostrKeyValue << &_chTemp[2] << " ";

             iCounter++;
             switch (iCounter)
             {
               case 8:
               {
                  lstrcat(chTemp, "- ");
                  //ostrKeyValue << "- ";
                  break;
               }
               case 16:
               {
                  lstrcat(chTemp, "\r\n");
                  //ostrKeyValue << "\r\n";
                  iCounter = 0;
                  break;
               }
             } // switch (iCounter)
           } //   for (unsigned int i = 0; i < sz; i++)

           wsprintf (chMessage, "Binary Value\r\n\r\n");
           lstrcat(chMessage, chTemp);
           /*
           if (sz > 160 )
           {
             wsprintf (chMesTemp, "...\r\n(%d bytes)", sz);
             lstrcat(chMessage, chMesTemp);
           }
           */
           break;
         }// case REG_BINARY:

         case REG_DWORD:
         {
		   chMessage  = new char[sz+32];	
           wsprintf (chMessage, "DWord Value\r\n\r\n %x", *((unsigned int *)szKeyValue));
           //ostrKeyValue << "DWord Value\r\n\r\n" << *((unsigned int *)szKeyValue);
           break;
         } // case REG_DWORD:

         default:
         {
           wsprintf (chMessage, "Value is unknown type.");
           //ostrKeyValue << "Value is unknown type.";
           break;
         } // default:
       } // switch (dt)

       wsprintf (chTitle  , "%s\\%s", szKeyName, szValueName);
       SetDlgItemText(hwnd, IDC_EB_VALUE, chMessage);
       //ostrKeyValue << '\0';
       //SetDlgItemText(hwnd, IDC_EB_VALUE, ostrKeyValue.str());

       RegCloseKey(hKey);
     }
     else
     {
      SetDlgItemText(hwnd, IDC_EB_VALUE, "Value not found");
     }
   }
   else
   {
     SetDlgItemText(hwnd, IDC_EB_VALUE, "Value is empty");
     /*
     MessageBox(hwnd, "Value Name is empty,\n let it be...", "Alert", MB_OK);
     DWORD lpcbValueName = 255;
     DWORD lpType;
     DWORD lpcbData      = 255;

     while ( RegEnumValue (hKey,iValueIndex, szValueName, &lpcbValueName, NULL, &lpType, (LPBYTE)&szKeyValue, &lpcbData) != ERROR_NO_MORE_ITEMS)
     {
       wsprintf (chMessage, "%s = %s",szValueName,(LPARAM)szKeyValue);
       MessageBox(hwnd, chMessage, "Find value:", MB_OK);

       lpcbValueName = 255;
       lpcbData      = 255;
       iValueIndex++;
     }
     wsprintf (chMessage, "Total = %d",iValueIndex);
     MessageBox(hwnd, chMessage, "Total values:", MB_OK);
    */
   }
  }
  else
  {
    SetDlgItemText(hwnd, IDC_EB_VALUE, "Key not found");
  }
}


void DelValueYes(HWND hwnd)
{
    if (MessageBox(hwnd, "Do you really want to delete this value ?", "Confirm", MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2) == IDYES)
    {

      if (RegOpenKeyEx(szRootKeyName, szKeyName,0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
      {
        if (RegDeleteValue(hKey,szValueName) == ERROR_SUCCESS)
          {MessageBox(hwnd, "Value was deleted", "Success", MB_OK+MB_ICONINFORMATION);}
        else
          {MessageBox(hwnd, "Can`t delete value", "Oblom ;)", MB_OK+MB_ICONERROR);}
      }
      else
        {MessageBox(hwnd, "Can`t delete value, key not found", "Oblom ;)", MB_OK+MB_ICONERROR);}

      /*
      wsprintf(chMessage," . \n-      ;)");
      MessageBox(hwnd,chMessage, " :(",MB_OK);
      */
    }
}

void SaveReg(HWND hwnd)
{
  HKEY hKey;
  RegCreateKey(HKEY_LOCAL_MACHINE, szRegRoot, &hKey);
   RegSetValueEx(hKey, "iRootKeyName",  NULL, REG_DWORD,(LPBYTE)&iRootKeyName,  sizeof(iRootKeyName));
   RegSetValueEx(hKey, "szKeyName00",   NULL, REG_SZ,(LPBYTE)szKeyName00,   strlen(szKeyName00));
   RegSetValueEx(hKey, "szKeyName01",   NULL, REG_SZ,(LPBYTE)szKeyName01,   strlen(szKeyName01));
   RegSetValueEx(hKey, "szKeyName02",   NULL, REG_SZ,(LPBYTE)szKeyName02,   strlen(szKeyName02));
   RegSetValueEx(hKey, "szValueName00", NULL, REG_SZ,(LPBYTE)szValueName00, strlen(szValueName00));
   RegSetValueEx(hKey, "szValueName01", NULL, REG_SZ,(LPBYTE)szValueName01, strlen(szValueName01));
   RegSetValueEx(hKey, "szValueName02", NULL, REG_SZ,(LPBYTE)szValueName02, strlen(szValueName02));
  RegCloseKey(hKey);
}

void LoadReg()
{
  HKEY hKey;
  DWORD dtroot = REG_DWORD;
  RegOpenKey(HKEY_LOCAL_MACHINE, szRegRoot, &hKey);
   sz=sizeof(iRootKeyName);
   RegQueryValueEx(hKey, "iRootKeyName",  NULL, &dtroot, (LPBYTE)&iRootKeyName,  &sz);
   sz=255;
   RegQueryValueEx(hKey, "szKeyName00",   NULL, &dt, (LPBYTE)szKeyName00,   &sz);
   sz=255;
   RegQueryValueEx(hKey, "szKeyName01",   NULL, &dt, (LPBYTE)szKeyName01,   &sz);
   sz=255;
   RegQueryValueEx(hKey, "szKeyName02",   NULL, &dt, (LPBYTE)szKeyName02,   &sz);
   sz=255;
   RegQueryValueEx(hKey, "szValueName00", NULL, &dt, (LPBYTE)szValueName00, &sz);
   sz=255;
   RegQueryValueEx(hKey, "szValueName01", NULL, &dt, (LPBYTE)szValueName01, &sz);
   sz=255;
   RegQueryValueEx(hKey, "szValueName02", NULL, &dt, (LPBYTE)szValueName02, &sz);
  RegCloseKey(hKey);
}
